<link rel="import" href="../polymer/polymer-element.html">

<dom-module id="fotosocial-update-post-dm">
  <template>
  </template>

  <script>
    /**
     * `fotosocial-update-post-dm`
     * data manager que actualiza la información de un post
     *
     * @customElement
     * @polymer
     * @demo demo/index.html
     */
    class FotosocialUpdatePostDm extends Polymer.Element {
      static get is() { return 'fotosocial-update-post-dm'; }
      static get properties() {
        return {
        };
      }

      updateLikesUnlikes(logUser, userSelected, post) {
        let fotosocial = JSON.parse(localStorage.getItem('fotosocial'));
        let locUserSelected = fotosocial.users.find(el => el.user === userSelected);
        let postSelected = locUserSelected.posts.find(el => el.id === post.postId);
        if (post.likeUnlike === 'like') {
          if (postSelected.likes === 0) {
            postSelected.likes = new Array();
          }
          if (!postSelected.likes.includes(logUser)) {
            postSelected.likes.push(logUser);
          }
        } else if (post.likeUnlike === 'unlike') {
          if (postSelected.unlikes === 0) {
            postSelected.unlikes = new Array();
          }
          if (!postSelected.unlikes.includes(logUser)) {
            postSelected.unlikes.push(logUser);
          }
        }
        fotosocial.users = fotosocial.users.map(el => {
          if (el === locUserSelected) {
            let updatedPosts = el.posts.map( post => {
              if (post.id === postSelected.id) {
                return postSelected;
              } else {
                return post;
              }
            });
            let updatedUser = el;
            updatedUser.posts = updatedPosts;
            return updatedUser;
          } else {
            return el;
          }
        });
        localStorage.setItem('fotosocial', JSON.stringify(fotosocial));
        this.dispatchEvent(new CustomEvent('like-unlike-success', {
          bubbles: true,
          composed: true,
          detail: {}
        }));
      }
    }

    window.customElements.define(FotosocialUpdatePostDm.is, FotosocialUpdatePostDm);
  </script>
</dom-module>
